const _excluded = ["classNamesContent", "onChange", "onViewLifecycle", "onExternalChange", "value", "extensions", "effects"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var s = Object.getOwnPropertySymbols(e); for (r = 0; r < s.length; r++) o = s[r], t.includes(o) || {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (e.includes(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { EditorView } from '@codemirror/view';
import { Compartment } from '@codemirror/state';
import { useCodeMirror } from '@ui-schema/kit-codemirror/useCodeMirror';
import { useEditorClasses } from '@ui-schema/kit-codemirror/useEditorClasses';
export const CodeMirror = _ref => {
  let {
      classNamesContent,
      onChange,
      onViewLifecycle,
      onExternalChange,
      value = '',
      extensions,
      effects
    } = _ref,
    props = _objectWithoutProperties(_ref, _excluded);
  const containerRef = React.useRef(null);
  const editorAttributesCompartment = React.useRef(new Compartment());
  const extensionsAll = React.useMemo(() => [editorAttributesCompartment.current.of(EditorView.editorAttributes.of({})), ...(extensions || [])], [extensions]);
  const editor = useCodeMirror(onChange, value, extensionsAll, effects, containerRef, onExternalChange, onViewLifecycle);
  useEditorClasses(editorAttributesCompartment.current, editor, classNamesContent);
  return React.createElement("div", _extends({
    ref: containerRef
  }, props));
};